#! /usr/bin/env python

# Scrivere un programma che data una lista o un file di parole stampi gli anagrammi 

#Come ulteriore esercizio, partendo da questi metodi, modificarlo in modo che data una parola, trovi gli anagrammi solo di quella parola

def ordina(s):
    "ordina una stringa e la ritorna"
    t = list(s)
    t.sort()
    t = ''.join(t)
    return t

def calcola_anagrammi(filename):
    d = {}
    for linea in open(filename):
        parola = linea.strip().lower()
        t = ordina(parola)

        if t not in d:
            d[t] = [parola]
        else:
            d[t].append(parola)
    return d

def stampa_anagrammi(d):
    for v in d.values():
        if len(v) > 1:
            print len(v), v

def stampa_anagrammi_in_ordine(d):
    t = []
    for v in d.values():
        if len(v) > 1:
            t.append((len(v), v))
    t.sort(reverse=True)
    for x in t:
        print x



if __name__ == "__main__":
	
	d = calcola_anagrammi('words_italiano.txt')
	stampa_anagrammi_in_ordine(d)